import re
from jeb.api import IScript
from jeb.api.ui import View 

class FocusedMethodList(IScript):

    def run(self, jeb):
        self.jeb = jeb
        self.ui = jeb.getUI()
        self.dex = jeb.getDex()
        self.start()

    def start(self):
        # get assembly view
        view = self.ui.getView(View.Type.ASSEMBLY)
        # get signature from caret position
        msig = view.getCodePosition().getSignature()

        cls_sig = re.sub(r'->.*', '', msig)
        cls = self.dex.getClass(cls_sig)
        cls_name = self.dex.getType(cls.getClasstypeIndex())
        print 'target class: ' + cls_name


        cls_data = cls.getData()
        print 'direct methods:'
        for md in cls_data.getDirectMethods():
            meth = self.dex.getMethod(md.getMethodIndex())
            print "\t%s->%s" % (cls_name, meth.getName()) 
        print 'virtual methods:'
        for md in cls_data.getVirtualMethods():
            meth = self.dex.getMethod(md.getMethodIndex())
            print "\t%s->%s" % (cls_name, meth.getName()) 


