from jeb.api import IScript
from jeb.api.ui import View 

class References(IScript):

    def run(self, jeb):
        self.jeb = jeb
        self.ui = jeb.getUI()
        self.dex = jeb.getDex()
        self.start()

    def start(self):
        # get assembly view
        view = self.ui.getView(View.Type.ASSEMBLY)
        # get signature from caret position
        msig = view.getCodePosition().getSignature()

        msigs = self.dex.getMethodSignatures(False)
        refs = []
        focus_type = ""
        if "->" in msig:
            if "(" in msig:
                focus_type = "method"
                index = msigs.indexOf(msig)
                refs = self.dex.getMethodReferences(index)
            else:
                focus_type = "field"
                f = self.dex.getFieldData(msig)
                refs = self.dex.getFieldReferences(f.getFieldIndex())
        else:
            focus_type = "class"
            cls = self.dex.getClass(msig)
            refs = self.dex.getTypeReferences(cls.getClasstypeIndex())

        print "%s(%s)" % (msig, focus_type)

        if refs is None:
            print "no references"
            return

        refs = list(set(refs))

        for midx in refs:
            print "\t" + msigs[midx]
